#include "Bumper.hpp"

Bumper::Bumper(PinName pin, NerfusCallbackInterface* nerfus_rise_callback) :
    interrupt_in(pin),
    nerfus_rise_callback(nerfus_rise_callback)
{        
    interrupt_in.rise(callback(this, &Bumper::rise_callback));
}

void Bumper::set_callbacks(NerfusCallbackInterface* nerfus_rise_callback)
{
    this->nerfus_rise_callback = nerfus_rise_callback;
}
        
void Bumper::rise_callback()
{
    if(nerfus_rise_callback)
    {
        nerfus_rise_callback->call();
    }
}
